' We are using a combination of SystemInternal's BgInfo and CTRL-ALT-DEL's TSbackdrop to create a nice
' informative wallpaper for all Terminal/Citrix server users.

' Thanks to Warren Simondson at CTRL-ALT-DEL for making the required modifications to TSbackdrop so
' that I could reference the BGinfo.bmp bitmap file.

' Version 1.2 released on 21st October 2009.
' Written by Jeremy@jhouseconsulting.com on 27th October 2008.

Option Explicit

Dim WshShell, fso, strProgramFiles, strSystemRoot, strUserTemp, strKey
Dim strBGInfoLocation, strTSBackdropLocation, strCommandLine

set WshShell = WScript.CreateObject("WScript.Shell")
set fso = CreateObject("Scripting.FileSystemObject")

strProgramFiles = WshShell.ExpandEnvironmentStrings("%ProgramFiles%")
strSystemRoot = WshShell.ExpandEnvironmentStrings("%SystemRoot%")
strUserTemp = WshShell.ExpandEnvironmentStrings("%Temp%")

strKey = "HKCU\Control Panel\Desktop\"

strBGInfoLocation = strProgramFiles & "\BGInfo\Bginfo.exe"
strTSBackdropLocation = strProgramFiles & "\BGInfo\TSBackdrop.exe"

If fso.FileExists(strBGInfoLocation) Then
  If RegValueExists(strKey & "Wallpaper") Then
    WshShell.RegDelete strKey & "Wallpaper"
  End If
  strCommandLine = chr(34) & strBGInfoLocation & chr(34) & " " & chr(34) & strProgramFiles & "\BGInfo\standard.bgi" & chr(34) & " " & "/timer:0 /NOLICPROMPT"
  WshShell.Run strCommandLine, 7, True
End If

If fso.FileExists(strTSBackdropLocation) Then
  If fso.FileExists(strUserTemp & "\bginfo.bmp") Then
    strCommandLine = chr(34) & strTSBackdropLocation & chr(34) & " " & chr(34) & strUserTemp & "\bginfo.bmp" & chr(34)
  ElseIf fso.FileExists(strUserTemp & "\bginfo.bmp") Then
    strCommandLine = chr(34) & strTSBackdropLocation & chr(34) & " " & chr(34) & strSystemRoot & "\bginfo.bmp" & chr(34)
  Else
    strCommandLine = chr(34) & strTSBackdropLocation & chr(34)
  End If
  WshShell.Run strCommandLine, 7, True
End If

Set WshShell=Nothing
set fso=Nothing

wscript.quit(0)

Function RegValueExists(sRegValue)
' Returns True or False based of the existence of a registry value.
  Dim oShell, RegReadReturn
  Set oShell = CreateObject("WScript.Shell")
  RegValueExists = True  ' init value
  On Error Resume Next
  RegReadReturn = oShell.RegRead(sRegValue)
  If Err.Number <> 0 Then
    RegValueExists = False
  End if
  On Error Goto 0
  Set oShell = Nothing
End Function
